import filters from './filters';
import components from './components';
import eventHub from './plugins/event-hub';
import { ajax, modelUtils, commonUtils, domUtils, treeUtils } from './utils';
import directives from './directives';
import * as consts from './consts';
import Filter from './utils/filter'
import enhance from './utils/enhance-comp'

export {
  consts, ajax, modelUtils,
  commonUtils, domUtils,
  treeUtils,
  Filter,
  enhance
};
export default {
  install(Vue, options) {
    Vue.use(filters);
    Vue.use(eventHub);
    Vue.use(directives);
    Vue.use(components);
  }
}
