export default {
  /**
   * iview table列定义字段
   */
  columnsProps: ['key', 'title', 'align', 'sortable', 'sortMethod', 'sortType', 'width', 'render', 'className', 'fixed', 'renderHeader', 'ellipsis', 'filters', 'filterMethod', 'filterMultiple', 'filteredValue', 'filterRemote'],
  /**
   * 根据字段定义获取iview table列定义
   * @param {*} fields
   */
  getColumns(fields) {
    return _.map(_.filter(_.sortBy(fields, 'order'), field => field.showInColumn), field => {
      return _.pick(field, this.columnsProps);
    });
  },
  /**
  * 根据字段定义获取默认model
  * @param {*} fields
  */
  getDefaults(fields) {
    return _.transform(fields, (result, field) => {
      result[field.key] = field.default;
    }, {});
  },
  /**
  * 根据字段定义获取表单验证规则
  * @param {*} fields
  */
  getRules(fields) {
    return _.transform(fields, (result, field) => {
      result[field.key] = field.rules;
    }, {});
  }
}
