const path = require('path');
const webpack = require('webpack');
const resolve = dir => path.join(__dirname, dir);

module.exports = {
  entry: resolve('src/index.js'),
  output: {
    path: resolve('dist'),
    filename: 'cpt-toolkit.js',
    library: 'cptToolkit',
    libraryTarget: 'umd',
    umdNamedDefine: true
  },
  externals: {
    vue: 'vue',
    iview: 'iview',
    moment: 'moment',
    axios: 'axios',
    lodash: {
      commonjs: 'lodash',
      commonjs2: 'lodash',
      amd: 'lodash',
      root: '_'
    },
    is_js: 'is_js'
  },
  module: {
    rules: [{
      test: /\.js$/,
      loader: 'babel-loader',
      exclude: /node_modules/,
    }, {
      test: /\.vue$/,
      loader: 'vue-loader',
      exclude: /node_modules/,
    }]
  },
  resolve: {
    extensions: ['.vue', '.js', '.json', '.css', '.less'],
    alias: {
      vue: 'vue/dist/vue.js',
      "@": resolve('src')
    },
  }
}
